#include "SL.h"
#include "PLA_GA_interface.h"

typedef int            *GA_Object
typedef SL_LAObj        PLA_LAObj
typedef SL_Template     PLA_Template


int PLA_GA_to_PLA_Create(GA_Object        ga_object,
                         PLA_LAObj        pla_object)
{
  int  m,               /* BLAS M parameter                        */
       n,               /* BLAS N parameter                        */ 
       k,               /* BLAS K parameter                        */
       return_value = 0;
       iuseless;        /* resync */
  int  nb;              /* Scalable BLAS blocking parameter        */
  int  r, c;            /* logical mesh dimensions                 */
  int  me;              /* my node index                           */
  int  ndims, dims[2];  /* for 2-D MPI_Comm creation               */
  int  periods[2];      /* S.A.A. Do we wrap the Comm. mesh        */
  int  reorder;         /* Allow/disallow re-ordering of proc #s   */
  MPI_Comm comm2d;      /* The 2-D communicator used               */
  int            GA_Datatype;
  MPI_Datatype   PLA_Datatype;
  SL_Template template=NULL;

/* Initialize MPI                                  */
/*  MPI_Init( &argc, &argv ); */
/* Extract me                                      */

   return_value += ga_inquire(ga_object, &GA_Data
  MPI_Comm_rank( MPI_COMM_WORLD, &me );

  if ( me == 0 )
  {
	 printf("Input #procs/row, #procs/col\n");
	 scanf( "%d%d", &r, &c );
  }
  MPI_Bcast( &r, 1, MPI_INT, 0, MPI_COMM_WORLD );
  MPI_Bcast( &c, 1, MPI_INT, 0, MPI_COMM_WORLD );
  /* Create 2D communicator    -- make a function                  */
  ndims = 2;                         /* 2-Dimensional Communicator */
  dims[0] = r; dims[1] = c;                /* r x c grid */
  periods[0] = TRUE; periods[1] = TRUE;    /* Torus */
  reorder = FALSE;       /* dis-allows processors to be re-ordered */
  MPI_Cart_create(MPI_COMM_WORLD, ndims, dims, periods, reorder, &comm2d);
					 /* Get blocking parameter, nb, and broadcast       */
/*  if ( me == 0 )
  {
	 printf("Input nb\n");
	 scanf( "%d", &nb );
  }
  MPI_Bcast( &nb, 1, MPI_INT, 0, MPI_COMM_WORLD );
  SL_Temp_create( comm2d, nb, 0, &template ); */
}
 
